import * as i0 from '@angular/core';
import { Directive, Optional, Inject, ElementRef, HostListener, Self, Input, NgModule } from '@angular/core';
import { CheckboxControlValueAccessor, DefaultValueAccessor, COMPOSITION_BUFFER_MODE, SelectControlValueAccessor, SelectMultipleControlValueAccessor, NG_VALUE_ACCESSOR } from '@angular/forms';
import { provideValueAccessor } from '@s-libs/ng-core';
import { noop, isNil } from '@s-libs/micro-dash';

/** @hidden */
class CheckboxValueAccessorDirective extends CheckboxControlValueAccessor {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: CheckboxValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: CheckboxValueAccessorDirective, selector: "input[type=checkbox][nasModel]", host: { listeners: { "change": "onChange($event.target.checked)", "blur": "onTouched()" } }, providers: [provideValueAccessor(CheckboxValueAccessorDirective)], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: CheckboxValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[type=checkbox][nasModel]',
                    // eslint-disable-next-line @angular-eslint/no-host-metadata-property
                    host: {
                        '(change)': 'onChange($event.target.checked)',
                        '(blur)': 'onTouched()',
                    },
                    providers: [provideValueAccessor(CheckboxValueAccessorDirective)],
                }]
        }] });

/** @hidden */
class InputValueAccessorDirective extends DefaultValueAccessor {
    constructor(renderer, elementRef, _compositionMode) {
        super(renderer, elementRef, _compositionMode);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: InputValueAccessorDirective, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }, { token: COMPOSITION_BUFFER_MODE, optional: true }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: InputValueAccessorDirective, selector: "input:not([type=checkbox]):not([type=number]):not([type=radio]):not([type=range])[nasModel],textarea[nasModel]", host: { listeners: { "input": "$any(this)._handleInput($event.target.value)", "blur": "onTouched()", "compositionstart": "$any(this)._compositionStart()", "compositionend": "$any(this)._compositionEnd($event.target.value)" } }, providers: [provideValueAccessor(InputValueAccessorDirective)], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: InputValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input:not([type=checkbox]):not([type=number]):not([type=radio]):not([type=range])[nasModel],textarea[nasModel]',
                    // eslint-disable-next-line @angular-eslint/no-host-metadata-property
                    host: {
                        '(input)': '$any(this)._handleInput($event.target.value)',
                        '(blur)': 'onTouched()',
                        '(compositionstart)': '$any(this)._compositionStart()',
                        '(compositionend)': '$any(this)._compositionEnd($event.target.value)',
                    },
                    providers: [provideValueAccessor(InputValueAccessorDirective)],
                }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [COMPOSITION_BUFFER_MODE]
                }] }]; } });

class AbstractValueAccessorDirective {
    constructor(injector) {
        this.onTouchedFn = noop;
        this.elementRef = injector.get(ElementRef);
    }
    get element() {
        return this.elementRef.nativeElement;
    }
    registerOnChange(fn) {
        this.onChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouchedFn = fn;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: AbstractValueAccessorDirective, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: AbstractValueAccessorDirective, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: AbstractValueAccessorDirective, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i0.Injector }]; } });

class AbstractInputValueAccessorDirective extends AbstractValueAccessorDirective {
    onChange() {
        this.onChangeFn(this.element.value);
    }
    onBlur() {
        this.onTouchedFn();
    }
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types -- required so subclass can make it `number`
    writeValue(value) {
        this.element.value = value;
    }
    setDisabledState(isDisabled) {
        this.element.disabled = isDisabled;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: AbstractInputValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: AbstractInputValueAccessorDirective, host: { listeners: { "change": "onChange()", "input": "onChange()", "blur": "onBlur()" } }, usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: AbstractInputValueAccessorDirective, decorators: [{
            type: Directive
        }], propDecorators: { onChange: [{
                type: HostListener,
                args: ['change']
            }, {
                type: HostListener,
                args: ['input']
            }], onBlur: [{
                type: HostListener,
                args: ['blur']
            }] } });

/** @hidden */
class NumberValueAccessorDirective extends AbstractInputValueAccessorDirective {
    registerOnChange(fn) {
        this.onChangeFn = (value) => {
            fn(value === '' ? null : parseFloat(value));
        };
    }
    writeValue(value) {
        // The value needs to be normalized for IE9, otherwise it is set to 'null' when null
        this.element.value = isNil(value) ? '' : value.toString();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: NumberValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: NumberValueAccessorDirective, selector: "input[type=number][nasModel]", providers: [provideValueAccessor(NumberValueAccessorDirective)], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: NumberValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[type=number][nasModel]',
                    providers: [provideValueAccessor(NumberValueAccessorDirective)],
                }]
        }] });

/** @hidden */
class RadioValueAccessorDirective extends AbstractInputValueAccessorDirective {
    async writeValue(obj) {
        // delay because `button.value` may not be set yet as the component is being initialized
        await Promise.resolve();
        this.element.checked = this.element.value === obj;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: RadioValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: RadioValueAccessorDirective, selector: "input[type=radio][nasModel]", providers: [provideValueAccessor(RadioValueAccessorDirective)], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: RadioValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[type=radio][nasModel]',
                    providers: [provideValueAccessor(RadioValueAccessorDirective)],
                }]
        }] });

/** @hidden */
class RangeValueAccessorDirective extends AbstractInputValueAccessorDirective {
    registerOnChange(fn) {
        this.onChangeFn = (value) => {
            fn(parseFloat(value));
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: RangeValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: RangeValueAccessorDirective, selector: "input[type=range][nasModel]", providers: [provideValueAccessor(RangeValueAccessorDirective)], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: RangeValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'input[type=range][nasModel]',
                    providers: [provideValueAccessor(RangeValueAccessorDirective)],
                }]
        }] });

/** @hidden */
class SelectValueAccessorDirective extends SelectControlValueAccessor {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: SelectValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: SelectValueAccessorDirective, selector: "select:not([multiple])[nasModel]", host: { listeners: { "change": "onChange($event.target.value)", "blur": "onTouched()" } }, providers: [
            provideValueAccessor(SelectValueAccessorDirective),
            {
                provide: SelectControlValueAccessor,
                useExisting: SelectValueAccessorDirective,
            },
        ], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: SelectValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'select:not([multiple])[nasModel]',
                    // eslint-disable-next-line @angular-eslint/no-host-metadata-property
                    host: {
                        '(change)': 'onChange($event.target.value)',
                        '(blur)': 'onTouched()',
                    },
                    providers: [
                        provideValueAccessor(SelectValueAccessorDirective),
                        {
                            provide: SelectControlValueAccessor,
                            useExisting: SelectValueAccessorDirective,
                        },
                    ],
                }]
        }] });

/** @hidden */
class SelectMultipleValueAccessorDirective extends SelectMultipleControlValueAccessor {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: SelectMultipleValueAccessorDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: SelectMultipleValueAccessorDirective, selector: "select[multiple][nasModel]", host: { listeners: { "change": "onChange($event.target)", "blur": "onTouched()" } }, providers: [
            provideValueAccessor(SelectMultipleValueAccessorDirective),
            {
                provide: SelectMultipleControlValueAccessor,
                useExisting: SelectMultipleValueAccessorDirective,
            },
        ], usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: SelectMultipleValueAccessorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'select[multiple][nasModel]',
                    // eslint-disable-next-line @angular-eslint/no-host-metadata-property
                    host: { '(change)': 'onChange($event.target)', '(blur)': 'onTouched()' },
                    providers: [
                        provideValueAccessor(SelectMultipleValueAccessorDirective),
                        {
                            provide: SelectMultipleControlValueAccessor,
                            useExisting: SelectMultipleValueAccessorDirective,
                        },
                    ],
                }]
        }] });

class NasModelDirective {
    #store;
    #subscription;
    #valueAccessor;
    constructor(valueAccessors) {
        this.#valueAccessor = valueAccessors[0];
    }
    set nasModel(store) {
        this.#subscription?.unsubscribe();
        this.#store = store;
        this.#subscription = store?.$.subscribe((value) => {
            this.#valueAccessor.writeValue(value);
        });
    }
    set disabled(isDisabled) {
        this.#valueAccessor.setDisabledState?.(isDisabled ?? false);
    }
    ngAfterViewInit() {
        this.#valueAccessor.registerOnChange((value) => {
            this.#store?.set(value);
        });
    }
    ngOnDestroy() {
        this.#subscription?.unsubscribe();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: NasModelDirective, deps: [{ token: NG_VALUE_ACCESSOR, self: true }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.0", type: NasModelDirective, selector: "[nasModel]", inputs: { nasModel: "nasModel", disabled: "disabled" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: NasModelDirective, decorators: [{
            type: Directive,
            args: [{ selector: '[nasModel]' }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Self
                }, {
                    type: Inject,
                    args: [NG_VALUE_ACCESSOR]
                }] }]; }, propDecorators: { nasModel: [{
                type: Input
            }], disabled: [{
                type: Input
            }] } });

const exportedDirectives = [
    CheckboxValueAccessorDirective,
    InputValueAccessorDirective,
    NasModelDirective,
    NumberValueAccessorDirective,
    RadioValueAccessorDirective,
    RangeValueAccessorDirective,
    SelectValueAccessorDirective,
    SelectMultipleValueAccessorDirective,
];
class NasModelModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: NasModelModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0", ngImport: i0, type: NasModelModule, declarations: [CheckboxValueAccessorDirective,
            InputValueAccessorDirective,
            NasModelDirective,
            NumberValueAccessorDirective,
            RadioValueAccessorDirective,
            RangeValueAccessorDirective,
            SelectValueAccessorDirective,
            SelectMultipleValueAccessorDirective], exports: [CheckboxValueAccessorDirective,
            InputValueAccessorDirective,
            NasModelDirective,
            NumberValueAccessorDirective,
            RadioValueAccessorDirective,
            RangeValueAccessorDirective,
            SelectValueAccessorDirective,
            SelectMultipleValueAccessorDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: NasModelModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0", ngImport: i0, type: NasModelModule, decorators: [{
            type: NgModule,
            args: [{ declarations: exportedDirectives, exports: exportedDirectives }]
        }] });

/*
 * Public API Surface of ng-app-state
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CheckboxValueAccessorDirective, InputValueAccessorDirective, NasModelDirective, NasModelModule, NumberValueAccessorDirective, RadioValueAccessorDirective, RangeValueAccessorDirective, SelectMultipleValueAccessorDirective, SelectValueAccessorDirective };
//# sourceMappingURL=ng-app-state.mjs.map
